/* TeamSCOPE - Software for Collaborative Project Environments.
   Copyright (C) 1999, 2000, 2001 Michigan State University.
   Written by Ben Pfaff <pfaffben@msu.edu>.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To contact the TeamSCOPE team, send email to scope@cscw.msu.edu, or
   write to Charles Steinfield, Room 436 Communication Arts Building,
   Michigan State University, Department of Telecommunication, East
   Lansing MI 48824-1212. */

#if !datetime_h
#define datetime_h 1

#include <time.h>

/* Date/time parsing options. */
enum
  {
    DT_UK = 004,		/* 1=Prefer dd/mm over mm/dd. */
    DT_DATE_REQUIRED = 010,	/* Do not default the date. */
    DT_TIME_REQUIRED = 020	/* Do not default the time. */
  };

extern const char *datetime_error;

struct context;

time_t datetime_parse (const char *, int options, time_t now, struct tm *tm);
const char *datetime_format (const char *template, const struct tm *tm);
int datetime_month_days (int year, int month);
void datetime_init_timezone (struct context *rq);

#endif /* datetime.h */
