/* TeamSCOPE - Software for Collaborative Project Environments.
   Copyright (C) 1999, 2000 Michigan State University.
   Written by Ben Pfaff <pfaffben@msu.edu>.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To contact the TeamSCOPE team, send email to scope@cscw.msu.edu, or
   write to Charles Steinfield, Room 436 Communication Arts Building,
   Michigan State University, Department of Telecommunication, East
   Lansing MI 48824-1212. */

#include <stdlib.h>
#include <string.h>
#include "postgres.h"
#include "utils/memutils.h"
#include "utils/palloc.h"

static const char *
find_last_word (const char *s, size_t len)
{
  const char *p = s + len;
  
  while (p > s && p[-1] == ' ')
    p--;
  while (p > s && p[-1] != ' ')
    p--;

  return p != s + len ? p : s;
}

text *
last_word (text *t)
{
  const char *lw;
  size_t len;
  text *copy;

  lw = find_last_word (VARDATA (t), VARSIZE (t) - VARHDRSZ);  
  len = (VARSIZE (t) - VARHDRSZ) - (lw - VARDATA (t));

  copy = palloc (VARHDRSZ + len);
#ifdef VARATT_SIZEP
  VARATT_SIZEP (copy) = len + VARHDRSZ;
#else
  VARSIZE (copy) = len + VARHDRSZ;
#endif
  memcpy (VARDATA (copy), lw, len);
  return copy;
}
